#include "StdAfx.h"
#include "CustomDic2.h"
#include "tstring.h"
#include "hash.hpp"
#include "Util.h"

CCustomDic2::CCustomDic2(void)
{
	NullWord.WordLen=-1;
	NullWord.WordN=-1;

	WordN=0;
	BookN=0;
}

CCustomDic2::~CCustomDic2(void)
{
}

void CCustomDic2::ResetDic()
{
	// ʱȭ
	KeyBook.clear();
	KeyIndex.clear();

	WordN=0;
	BookN=0;

	ValueList.clear();
}

void CCustomDic2::SetKey(LPCSTR JpnWord, LPCSTR KorWord)
{
	map<UINT,DicWord> EmptyMap;
	DicWord TempWord;

	map<int,int>::iterator iterIndex;

	TempWord.WordLen = (int)strlen(JpnWord);
	TempWord.WordN = WordN++;

	UINT Hash=MakeStringHash(JpnWord);
	int IndexChar=(int)TempWord.WordLen*65536+JpnWord[1];
	int ValuePointer=0;

	iterIndex = KeyIndex.find(IndexChar);
	if(iterIndex==KeyIndex.end()){
		//  ʴٸ
		KeyIndex[IndexChar]=BookN;
		KeyBook.push_back(EmptyMap);
		//  ִ´.

		ValuePointer=BookN++;
	}
	else{
		// ִٸ
		ValuePointer=iterIndex->second;
	}

	KeyBook[ValuePointer][Hash]=TempWord;
	ValueList.push_back(KorWord);
	//
}

string CCustomDic2::GetValue(int KeyN)
{
	return ValueList[KeyN];
	//
}

DicWord CCustomDic2::FindKey(LPCSTR Source, int Start, int End)
{
	//켱 ڿ ߶󳻵  ==;
	char FindText[2048]="";
	int _End=(int)strlen(Source)-1; //''̴ϱ

	if(End!=-1 && End<=_End){
		//End -1 ƴϰ(-1 !)
		//End 밡   ִٸ.
		_End=End;
	}

	int TextLen=0;
	for(int i=Start;i<=End;i++)FindText[TextLen++]=Source[i];
	FindText[TextLen]='\0';
	//


	//˻ ۾ .
	map<int,int>::iterator iterIndex;
	int IndexChar=65536*TextLen+FindText[1];

	iterIndex = KeyIndex.find(IndexChar); //1 ˻
	if(iterIndex==KeyIndex.end()){
		// ٸ.
		return NullWord;
	}
	else{
		UINT Hash=MakeStringHash(FindText); //Hash
		map<UINT,DicWord>::iterator iterBook;

		int ValuePointer=iterIndex->second;

		iterBook = KeyBook[ValuePointer].find(Hash); //2 ˻
		if(iterBook != KeyBook[ValuePointer].end()){
			//2ܰ  ִٸ,
			return iterBook->second;
		}
		else{
			//⵵ ٸ,
			return NullWord;
		}
	}
}

void CCustomDic2::AddDic(int Mode, LPCWSTR CustomPath)
{
	// 
	wchar_t Path[4096]=L"";
	int PathLen=(int)wcslen(CustomPath);
	
	

	
	//Mode 
	//0 -  
	//1 - GDic
	// - CDic

	if(Mode==0)
	{
		wcscpy_s(Path,4096,CustomPath);
		for(int i=PathLen-1;i>=0;i--){
			if(Path[i]==L'\\'){
				// 丮ΰ ٸ!
				wchar_t CharTmp=Path[i+1];
				Path[i+1]=L'\0';
				MyCreateDirectory(Path); //ϴ  Ѿ!
				Path[i+1]=CharTmp;
				break;
			}
		}
	}
	else if(Mode==1)
	{
		wcscpy_s(Path,4096,GetATDirectory());
		wcscat_s(Path,4096,L"\\");
		MyCreateDirectory(Path);
		wcscat_s(Path,4096,L"CustomDic.txt");
	}
	else
	{
		wcscpy_s(Path,4096,GetGameDirectory());
		wcscat_s(Path,4096,L"\\ATData\\");
		MyCreateDirectory(Path);
		wcscat_s(Path,4096,L"CustomDic.txt");
	}

	//   ݾ  Ȼ  [...]

	FILE * Src;

	_wfopen_s(&Src,Path,L"rt,ccs=UTF-8");

	if(!Src)
	{
		// ٸ,  .
		_wfopen_s(&Src,Path,L"wt,ccs=UTF-8");
		if(Src)
		{
			fwprintf(Src,L"///////////////////////////\n");
			fwprintf(Src,L"//  \n");
			fwprintf(Src,L"///////////////////////////\n");
			fwprintf(Src,L"//\n");
			fwprintf(Src,L"//\n");
			fclose(Src);
		}
	}
	else
	{
		wchar_t _LineIn[3500]=L""; //LPSTR 2048 Ѱϱ, ؼ 1024 * 3 + ణ 

		// ȴٸ 'д´'
		while(fgetws(_LineIn,3456,Src))
		{
			int LineLen=0;

			wstring LineIn=L"";
			wstring JpnWLine=L"";
			wstring KorWLine=L"";

			int Tmp=0;

			LineLen=(int)wcslen(_LineIn);
			if(_LineIn[LineLen-1]==L'\n')LineLen--; // 
			for(Tmp=1;Tmp<LineLen;Tmp++){
				if(_LineIn[Tmp-1]==L'/' && _LineIn[Tmp]==L'/'){
					//ּ ȣ ãҴٸ
					Tmp--;
					break;
				}
			}
			LineIn=wstring(_LineIn,Tmp);
			LineLen=Tmp;
			//ּ ó Ϸ. ĺ wstring LineIn ó
			
			int Tab[3][2]={0,0,0,0,0,0};
			int TabFlag=0;

			//ã, 3 ķδ  ʿ䰡 .
			for(Tmp=0;Tmp<LineLen;Tmp++){
				if(LineIn[Tmp]==L'\t'){
					if(TabFlag==5)
					{
						//  
						break;
					}
					else 
					{
						if(TabFlag%2==0)
						{
							//TabFlag ¦(head)
							Tab[TabFlag/2][0]=Tmp;
							TabFlag++;
						}
						if(TabFlag%2==1)
						{
							//TabFlag Ȧ(tail)
							// 쿣  ڱ ã´
							Tab[TabFlag/2][1]=Tmp;

							if(LineIn[Tmp+1]!=L'\t')TabFlag++;
						}
					}
				}
			}//ã 

			int RealTab=0;
			if(Tab[2][0]!=0){
				RealTab=3;
			}
			else if(Tab[1][0]!=0){
				RealTab=2;
			}
			else if(Tab[0][0]!=0){
				RealTab=1;
			}
			// 

			/*
			     ==;
			ٸ ̾Ƴ   װ  ġ[...]

			 
					ѱ	
			̹Ƿ ׳ ڸ ȴ.
			̶  Էµ ѱ  ڿ ȴ.

			 ΰ
					ѱ
				ѱ	
			ε,  ΰ ؾѴ

			 Ѱ
				ѱ
			̰  .

			 ٸ
			[...]

			  
			̰ 0   Ƿ   ʿ䰡 .
			*/

			bool WordSet=false;
			if(RealTab>0)JpnWLine=LineIn.substr(0,Tab[0][0]);
			else JpnWLine=LineIn.substr(0,LineLen);//  
			if(RealTab==3)
			{
				KorWLine=LineIn.substr(Tab[1][1]+1,Tab[2][0]-Tab[1][1]-1);
			}
			else if(RealTab==2)
			{
				if(Tab[1][1]!=LineLen-1){
					//  ȣ  ƴѰ,   ڰ ѱΰ
					KorWLine=LineIn.substr(Tab[1][1]+1,LineLen-Tab[1][1]-1);
				}
				else {
					//  ȣ ΰ
					KorWLine=LineIn.substr(Tab[0][1]+1,Tab[1][0]-Tab[0][1]-1);
				}
			}
			else if(RealTab==1 && Tab[0][1]!=LineLen-1)
			{
				KorWLine=LineIn.substr(Tab[0][1]+1,LineLen-Tab[0][1]-1);
			}

			//Ϻ, ѱ  Ϸ

			if(RealTab>0){
				char JpnALine[2048]="";
				char KorALine[2048]="";

				MyWideCharToMultiByte(932,0,JpnWLine.c_str(),-1,JpnALine,2048,NULL,NULL);
				MyWideCharToMultiByte(949,0,KorWLine.c_str(),-1,KorALine,2048,NULL,NULL);
				//Ansi ȯ

				SetKey(JpnALine,KorALine);
			}
			else if(RealTab==0&&LineLen>0){
				// 
				//Ǿ 常  ѱʿ ״ Ѹ.
				char JpnALine[2048]="";
				MyWideCharToMultiByte(932,0,JpnWLine.c_str(),-1,JpnALine,2048,NULL,NULL);
				SetKey(JpnALine,JpnALine);
			}
		}
		fclose(Src);
	}
	
}

void CCustomDic2::PreCustomDic(LPSTR Dest, LPCSTR Source)
{
	int SourceLen=(int)strlen(Source);
	DicWord TempWord;

	string Temp;
	int SPoint=0;

	char atoi_tmp[10]="";

	for(int head=0;head<SourceLen;head++)
	{
		for(int tail=SourceLen-1;tail>head;tail--)
		{
			char TTTTT[4096]="";
			int j=0;
			for(int i=head;i<=tail;i++)TTTTT[j++]=Source[i];
			TTTTT[j]='\0';
			TempWord=FindKey(Source,(int)head,(int)tail);
			if(TempWord.WordLen>0){
				// ִٸ!
				//̶ -1 (CCustomDic2::CCustomDic2 ) Ե
				
				//պκ 
				Temp+=string(Source,SPoint,head-SPoint);

				//ܾ ߰
				_itoa_s(TempWord.WordN,atoi_tmp,10,10);
				Temp+= "@*_D" + string(atoi_tmp) + '/'; // @*_D****/
				SPoint=tail+1;
				head=tail;
				break;
			}

			//2Ʈ ó, ӵ 
			if((BYTE)Source[tail]>0x80){
				tail--;
			}
		}

		//2Ʈ ó, ӵ 
		if((BYTE)Source[head]>0x80){
			//ڶ
			head++;
		}
	}
	Temp+=string(Source,SPoint,SourceLen-SPoint); //

	lstrcpyA(Dest,Temp.c_str());
}

void CCustomDic2::PostCustomDic(LPSTR Dest, LPCSTR Source)
{
	string Temp=Source;
	string Temp2="";
	//Temp -> Temp2 帧

	string::size_type DicTagHead = 0;
	string::size_type DicTagTail = -1;

	string::size_type LastTail = -1;

	for(;;){
		// ݺ
		DicTagHead=Temp.find("@*_D",DicTagTail+1);
		if(DicTagHead != string::npos)
		{
			// @*_D κ  ִٸ
			Temp2 += Temp.substr(DicTagTail+1,DicTagHead-DicTagTail-1);
			DicTagTail=Temp.find('/',DicTagHead);
			LastTail = DicTagTail;
			
			string WordTmp=Temp.substr(DicTagHead+4,(DicTagTail-1)-(DicTagHead+4)+1);
			// κ 
			Temp2 += GetValue(atoi(WordTmp.c_str()));
			//ڰ ȯؼ  ߰.
		}
		else{
			// ϱ[...]
			break;
		}
	}
	Temp2 += Temp.substr(LastTail+1,Temp.length()-LastTail-1);
	//[...]

	lstrcpyA(Dest,Temp2.c_str());
}